-- ===============================================
-- Author	  : FID.Intan	  
-- Create date: 11-Desember-2014
-- Description:	Insert Data to TB_T_DVL_FI_TRANS_H
-- Bug ID	  : 493
-- ===============================================

CREATE PROCEDURE [dbo].[SP_PROTO_INSERT_TEMP_TRANS_H_GR]
	@PROCESS_ID BIGINT
AS

DECLARE
	@DOC_NO VARCHAR(15),
	@DOC_NO_OLD VARCHAR(15),
	@DOC_YEAR VARCHAR(4),
	@DELIVERY_NOTE_NO VARCHAR(50),
	@DOC_DT VARCHAR(30),
	@REFF_NO VARCHAR(16),
	@SUPP_CD VARCHAR(50),
	@UPDATE_DT VARCHAR(30),
	@UPDATE_BY VARCHAR(50),
	@COUNTER INT
BEGIN
	--Get DOC Year
	SET @DOC_YEAR = CONVERT(VARCHAR, YEAR(GETDATE()))

	--Get DOC_NO from TB_R
	SELECT @DOC_NO_OLD = MAX(DOC_NO) FROM TB_R_DLV_FI_TRANS_H WHERE SUBSTRING(DOC_NO, 1, 3) = 'TWX'
	SET @DOC_NO_OLD = ISNULL(@DOC_NO_OLD, '0')
	IF(@DOC_NO_OLD <> '0')
	BEGIN
		SET @DOC_NO_OLD = SUBSTRING(@DOC_NO_OLD, 4, 12)
	END

	SET @COUNTER = 1

	DECLARE TransH_Cursor CURSOR FOR
		SELECT DISTINCT DELIVERY_NOTE_NO, SUPP_CD FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID
		OPEN TransH_Cursor

		FETCH NEXT FROM TransH_Cursor INTO @DELIVERY_NOTE_NO, @SUPP_CD
		WHILE(@@FETCH_STATUS = 0)
		BEGIN
			--Get Update Dt
			SELECT TOP 1 @UPDATE_DT = UPDATE_DT FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO AND SUPP_CD = @SUPP_CD

			--Get Update By
			SELECT TOP 1 @UPDATE_BY = UPDATE_BY FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO AND SUPP_CD = @SUPP_CD

			SET @DOC_NO = 'TWX' + RIGHT('000000000000' + CAST((@COUNTER + CONVERT(INT, @DOC_NO_OLD)) AS VARCHAR(12)), 12)

			SELECT @DOC_DT = MAX(CASE WHEN((UPDATE_DT = '') OR (UPDATE_DT = null)) THEN GETDATE() ELSE UPDATE_DT END) FROM TB_T_PROTO_GR WHERE DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO AND PROCESS_ID = @PROCESS_ID
			SELECT @REFF_NO = MAX(PO_NO) FROM TB_T_PROTO_GR WHERE DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO AND PROCESS_ID = @PROCESS_ID

			INSERT INTO TB_T_DLV_FI_TRANS_H VALUES (@DOC_NO, @DOC_YEAR, @DOC_DT, GETDATE(), @DELIVERY_NOTE_NO, CONVERT(VARCHAR(16), 
			@REFF_NO), NULL, RIGHT('0000' + CAST((SUBSTRING(@SUPP_CD, 1, 4)) AS VARCHAR(4)), 4), NULL, NULL, NULL, NULL, NULL, NULL, CONVERT(VARCHAR(20), @UPDATE_BY), 
			@UPDATE_DT, NULL, NULL, @PROCESS_ID, NULL)

			EXEC SP_PROTO_INSERT_TEMP_TRANS_D_GR @PROCESS_ID, @DELIVERY_NOTE_NO, @DOC_NO
			SET @COUNTER = @COUNTER + 1
			FETCH NEXT FROM TransH_Cursor INTO @DELIVERY_NOTE_NO, @SUPP_CD
		END

		CLOSE TransH_Cursor
	DEALLOCATE TransH_Cursor
END

